package com.maintain.business.listener;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.maintain.business.domain.ErpExamineProject;
import com.maintain.business.domain.ErpMaintainCause;
import com.maintain.business.domain.vo.ErpExamineProjectImportVo;
import com.maintain.business.domain.vo.ErpMaintainCauseImportVo;
import com.maintain.business.mapper.ErpExamineProjectMapper;
import com.maintain.business.mapper.ErpMaintainCauseMapper;
import com.maintain.common.excel.ExcelListener;
import com.maintain.common.excel.ExcelResult;
import com.maintain.common.exception.ServiceException;
import com.maintain.common.helper.LoginHelper;
import com.maintain.common.utils.ValidatorUtils;
import com.maintain.common.utils.spring.SpringUtils;
import lombok.extern.slf4j.Slf4j;

import java.util.List;

/**
 * 维修原因自定义导入
 *
 * @author liushuai
 */
@Slf4j
public class ErpMaintainCauseImportListener extends AnalysisEventListener<ErpMaintainCauseImportVo> implements ExcelListener<ErpMaintainCauseImportVo> {

    private final ErpMaintainCauseMapper maintainCauseMapper;

    private final Boolean isUpdateSupport;

    private final String operName;

    private int successNum = 0;
    private int failureNum = 0;
    private final StringBuilder successMsg = new StringBuilder();
    private final StringBuilder failureMsg = new StringBuilder();

    public ErpMaintainCauseImportListener(Boolean isUpdateSupport) {
        this.maintainCauseMapper = SpringUtils.getBean(ErpMaintainCauseMapper.class);
        this.isUpdateSupport = isUpdateSupport;
        this.operName = LoginHelper.getUsername();
    }

    @Override
    public void invoke(ErpMaintainCauseImportVo maintainCauseImportVo, AnalysisContext context) {
        LambdaQueryWrapper<ErpMaintainCause> lqw = new LambdaQueryWrapper<>();
        lqw.eq(ErpMaintainCause::getMaintainCauseCode, maintainCauseImportVo.getMaintainCauseCode());
        ErpMaintainCause erpMaintainCause = maintainCauseMapper.selectOne(lqw);
        try {
            // 验证是否存在这个维修原因
            if (ObjectUtil.isNull(erpMaintainCause)) {
                erpMaintainCause = BeanUtil.toBean(maintainCauseImportVo, ErpMaintainCause.class);
                ValidatorUtils.validate(erpMaintainCause);
                maintainCauseMapper.insert(erpMaintainCause);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、维修原因 ").append(erpMaintainCause.getMaintainCauseCode()).append(" 导入成功");
            } else if (isUpdateSupport) {
                Long maintainCauseId = erpMaintainCause.getId();
                erpMaintainCause = BeanUtil.toBean(maintainCauseImportVo, ErpMaintainCause.class);
                erpMaintainCause.setId(maintainCauseId);
                ValidatorUtils.validate(erpMaintainCause);
                maintainCauseMapper.updateById(erpMaintainCause);
                successNum++;
                successMsg.append("<br/>").append(successNum).append("、维修原因 ").append(erpMaintainCause.getMaintainCauseCode()).append(" 更新成功");
            } else {
                failureNum++;
                failureMsg.append("<br/>").append(failureNum).append("、维修原因 ").append(erpMaintainCause.getMaintainCauseCode()).append(" 已存在");
            }
        } catch (Exception e) {
            failureNum++;
            String msg = "<br/>" + failureNum + "、维修原因 " + erpMaintainCause.getMaintainCauseCode() + " 导入失败：";
            failureMsg.append(msg).append(e.getMessage());
            log.error(msg, e);
        }

    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {

    }

    @Override
    public ExcelResult<ErpMaintainCauseImportVo> getExcelResult() {
        return new ExcelResult<ErpMaintainCauseImportVo>() {

            @Override
            public String getAnalysis() {
                if (failureNum > 0) {
                    failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据格式不正确，错误如下：");
                    throw new ServiceException(failureMsg.toString());
                } else {
                    successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
                }
                return successMsg.toString();
            }

            @Override
            public List<ErpMaintainCauseImportVo> getList() {
                return null;
            }

            @Override
            public List<String> getErrorList() {
                return null;
            }
        };
    }
}
